// BaseView.cpp 
// Copyright ЃACrX http://www.ibis.ne.jp/
//          _Jh kamiya@ibis.ne.jp
// ŁF2002/4/19

#include "stdafx.h"
#include <math.h>
#include "Vector2d.h"
#include "Base.h"

#include "BaseDoc.h"
#include "BaseView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

static const double PI = 3.141592;
inline double DEG2RAD(double dDegree) {
	return 2.0 * PI * dDegree / 360.0;
}
inline double Rand() {
	return (double)rand() / 32768.0;
}
/////////////////////////////////////////////////////////////////////////////
// CBaseView

IMPLEMENT_DYNCREATE(CBaseView, CView)

BEGIN_MESSAGE_MAP(CBaseView, CView)
	//{{AFX_MSG_MAP(CBaseView)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_WM_TIMER()
	ON_WM_KEYDOWN()
	//}}AFX_MSG_MAP
	// WR}h
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBaseView NX̍\z/

CBaseView::CBaseView()
{
	//V[
	m_nScene = 2;
}

CBaseView::~CBaseView()
{
}

BOOL CBaseView::PreCreateWindow(CREATESTRUCT& cs)
{
	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CBaseView NX̕`

void CBaseView::OnDraw(CDC* pDC)
{
	//ԊǗ
	static DWORD dwPrev = GetTickCount();
	double dTick = ( GetTickCount() - dwPrev )/1000.0;
	dwPrev = GetTickCount();
	//ׂ
	static int nPrevScene = -1;
	bool bInit = false;
	if ( nPrevScene != m_nScene ) {//V[ςĂ
		bInit = true;
	}
	nPrevScene = m_nScene;
	//V[ɂ镪
	switch(m_nScene) {
	case 0:
		Draw00(pDC, dTick, bInit ); break;
	case 1:
		Draw01(pDC, dTick, bInit ); break;
	case 2:
		Draw02(pDC, dTick, bInit ); break;
/*	case 3:
		Draw03(pDC, dTick, bInit ); break;
	case 4:
		Draw04(pDC, dTick, bInit ); break;
	case 5:
		Draw05(pDC, dTick, bInit ); break;
	case 6:
		Draw06(pDC, dTick, bInit ); break;
	case 7:
		Draw07(pDC, dTick, bInit ); break;
	case 8:
		Draw08(pDC, dTick, bInit ); break;
	case 9:
		Draw09(pDC, dTick, bInit ); break;
	case 10:
		Draw10(pDC, dTick, bInit ); break;
	case 11:
		Draw11(pDC, dTick, bInit ); break;
	case 12:
		Draw12(pDC, dTick, bInit ); break;
	case 13:
		Draw13(pDC, dTick, bInit ); break;
	case 14:
		Draw14(pDC, dTick, bInit ); break;
	case 15:
		Draw15(pDC, dTick, bInit ); break;
	case 16:
		Draw16(pDC, dTick, bInit ); break;*/
	default:
		m_nScene = 0;
	}
	//V[\
	pDC->SetBkMode(TRANSPARENT);//͓̌
	pDC->TextOut(0,0,m_szSceneName);
	pDC->TextOut(0,20,"Press SPACE to Next Scene");
}

//V[0
//dTick : oߎԁiPʁFbj
//bInit : ׂ
void CBaseView::Draw00( CDC* pDC, double dTick, bool bInit )
{
	static double dScale = 20.f;
	static double dSpeed = 0.f;//Pm/s
	static double dX = 0.f;//Pm
	static double dWeight = 900.f;//Pkg
	if ( bInit ) {//
		strcpy(m_szSceneName,"ƌƋCR@@L[F[]ANZ@[]u[L@[]Y[C@[]Y[AEg");
		dX = 0.f;
		dSpeed = 0.f;
	}
	double f;//(kgm/s~2)
	//L[
	if ( GetAsyncKeyState( VK_LEFT ) < 0 ) {//ANZL[Ƃ
		dSpeed += 5000.f/dWeight * dTick;//(m/s~2)
	}
	if ( GetAsyncKeyState( VK_RIGHT ) < 0 ) {//u[LƂ
		dSpeed -= 10000.f/dWeight * dTick;//
		if ( dSpeed < 0.f ) {//x}CiX̂Ƃ
			dSpeed = 0.f;//xOɂ
		}
	}
	if ( GetAsyncKeyState( VK_UP ) < 0 ) {//Y[C
		dScale *= 1.1f;
	}
	if ( GetAsyncKeyState( VK_DOWN ) < 0 ) {//Y[C
		dScale *= 0.9f;
	}
	//CR(CR=CxxRWxfʐxx^2)
	dSpeed -= 4.f * dSpeed * dSpeed / dWeight * dTick;
	dX = dX + dSpeed * dTick;//xʒuiϕj
	//̕\
	char str[256];
	sprintf( str, "Speed %3.0fkm/h", dSpeed * 60.f * 60.f / 1000.f );
	pDC->TextOut( 5, 100, str );
	//nʂ̕`
	MoveTo( pDC, 0.f, 240.f+0.7*dScale );
	LineTo( pDC, 640.f, 240.f+0.7*dScale );
	//Ԃ̕`
	DrawCar(pDC, 320.f, 240.f, dScale);
	//؂̕`
	for ( f=dX-320.f/dScale ; f < dX+320.f/dScale ; f+=10.f ) {//10mƂɖ
		double f2 = floor(f/10.f)*10.f+10.f;
		DrawTree( pDC, 320.f-(f2-dX)*dScale, 240.f+0.7*dScale , dScale );
	}
}

//Ԃ̕`
void CBaseView::DrawCar( CDC* pDC, double x, double y, double s )
{
	static CVector2d vPoly[] = {//Ԃ̊O`i|Cj
		{CVector2d(-2.00f,0.4f)},
		{CVector2d(-1.90f,-0.2f)},
		{CVector2d(-1.00f,-0.4f)},
		{CVector2d(-0.60f,-0.9f)},
		{CVector2d(1.20f,-0.9f)},
		{CVector2d(1.60f,-0.4f)},
		{CVector2d(2.00f,-0.2f)},
		{CVector2d(2.00f,0.4f)},
		{CVector2d(-2.00f,0.4f)},
	};
	static CVector2d vWheel[2] = {//zC[̈ʒu
		{CVector2d(-1.2f, 0.4f)},
		{CVector2d(1.4f, 0.4f)},
	};

	for ( int i = 0 ; i < sizeof(vPoly)/sizeof(CVector2d) ; i++ ) {
		if ( i==0 ) {
			MoveTo( pDC, CVector2d( x+vPoly[i].GetX()*s, y+vPoly[i].GetY()*s ) );
		} else {
			LineTo( pDC, CVector2d( x+vPoly[i].GetX()*s, y+vPoly[i].GetY()*s ) );
		}
	}
	for ( i = 0 ; i < 2 ; i++ ) {
		Circle( pDC, CVector2d( x+vWheel[i].GetX()*s, 
			y+vWheel[i].GetY()*s ), 0.3f*s );
	}
}

//؂̕`
void CBaseView::DrawTree( CDC* pDC, double x, double y, double s )
{
	static CVector2d vPoly[] = {//؂̊O`i|Cj
		{CVector2d(0.0f,0.0f)},
		{CVector2d(-0.0f,-3.0f)},
		{CVector2d(-0.8f,-0.5f)},
		{CVector2d( 0.8f,-0.5f)},
		{CVector2d( 0.0f,-3.0f)},
		{CVector2d(-0.7f,-1.5f)},
		{CVector2d( 0.7f,-1.5f)},
		{CVector2d( 0.0f,-3.0f)},
	};
	for ( int i = 0 ; i < sizeof(vPoly)/sizeof(CVector2d) ; i++ ) {
		if ( i==0 ) {
			MoveTo( pDC, CVector2d( x+vPoly[i].GetX()*s, y+vPoly[i].GetY()*s ) );
		} else {
			LineTo( pDC, CVector2d( x+vPoly[i].GetX()*s, y+vPoly[i].GetY()*s ) );
		}
	}
}

//V[1
//dTick : oߎԁiPʁFbj
//bInit : ׂ
void CBaseView::Draw01( CDC* pDC, double dTick, bool bInit )
{
	static const double R = 0.1f;//{[̔a(m)
	static const double WEIGHT = 10.f;//{[̏d(kg)
	static const double GRAVITY = 9.8f;//d͉x(m/s^2)
	static const double E = 0.8f;//{[̒e
	static const double K = 100.f;//΂ˌW
	static CVector2d vPos;//{[̈ʒu
	static CVector2d vVelo;//{[̑x
	static bool bGrab;//{[ł邩
	static double dScale;
	if ( bInit ) {//
		strcpy(m_szSceneName,"тт{[@@[}EXhbO] {[");
		vPos = CVector2d( 3.20f, 2.40f );//ʒu͉ʒ
		vVelo = CVector2d( 0.f, 0.f );//xO
		bGrab = false;
		dScale = 100.f;
	}

	CVector2d vPoint = InputMouse();
	CVector2d v = vPos - vPoint;

	//}EX{^
	if ( GetAsyncKeyState( VK_LBUTTON ) < 0 ) {//{^Ă
		if ( v.GetLength() < R ) {//{[̔aȓȂ
			bGrab = true;
		}
	} else {//{^𗣂Ă
		bGrab = false;
	}

	CVector2d f;//(kgm/s~2)
	//d
	f = CVector2d( 0.f, GRAVITY * WEIGHT );//d
	vVelo += f / WEIGHT * dTick; //x(=/d)xiϕj
	//΂˂̗
	if ( bGrab ) {//{[ł
		f = v * -K;
		vVelo += f / WEIGHT * dTick; //x(=/d)xiϕj
	}
	//ʒuXV
	vPos += vVelo * dTick; //xʒuiϕj
	//ǂƂ̏Փ(̑傫́A6.4mA4.8mƂj
	if ( vPos.GetX() < R ) {//
		vPos.SetX( R );
		vVelo.SetX( -vVelo.GetX() * E );
	}
	if ( vPos.GetX() > 6.40f - R ) {//E
		vPos.SetX( 6.40f - R );
		vVelo.SetX( -vVelo.GetX() * E );
	}
	if ( vPos.GetY() > 4.80f - R ) {//
		vPos.SetY( 4.80f - R );
		vVelo.SetY( -vVelo.GetY() * E );
	}

	//nʂ̕`
	MoveTo( pDC, 0.f * dScale, 0.f * dScale );
	LineTo( pDC, 0.f * dScale, 4.80f * dScale );
	LineTo( pDC, 6.40f * dScale, 4.80f * dScale );
	LineTo( pDC, 6.40f * dScale, 0.f * dScale );

	//{[̕`
	Circle( pDC, vPos * dScale, R * dScale );

	//΂˂̕`
	if ( bGrab ) {
		MoveTo( pDC, vPos * dScale );
		LineTo( pDC, vPoint * dScale );
	}
}

//V[2
//dTick : oߎԁiPʁFbj
//bInit : ׂ
void CBaseView::Draw02( CDC* pDC, double dTick, bool bInit )
{
	class Ball {
	public:
		CVector2d vPos;//{[̈ʒu
		CVector2d vVelo;//{[̑x
		bool bGrab;//{[ł邩
	};
	static const double R = 0.1f;//{[̔a(m)
	static const double WEIGHT = 10.f;//{[̏d(kg)
	static const double GRAVITY = 9.8f;//d͉x(m/s^2)
	static const double E = 0.8f;//{[̒e
	static const double K = 100.f;//΂ˌW
	static const double LENGTH = 0.5f;//̒
	static const int NUM_SIM = 10;//V~[V
	static const int NUM = 2;//{[̐
	static Ball ball[NUM];//{[
	static double dScale;
	int i;
	if ( bInit ) {//
		strcpy(m_szSceneName,"Q̃{[@[}EXhbO] {[");
		for ( i = 0 ; i < NUM; i++ ) {
			ball[i].vPos = CVector2d( 3.20f+LENGTH*i, 2.40f );//ʒu͉ʒ
			ball[i].vVelo = CVector2d( 0.f, 0.f );//xO
			ball[i].bGrab = false;
		}
		dScale = 100.f;
	}

	CVector2d vPoint = InputMouse();
	//V~[V
	for ( int j = 0 ; j < NUM_SIM ; j++ ) {
		for ( i = 0 ; i < NUM ; i++ ) {
			CVector2d v = ball[i].vPos - vPoint;
			//}EX{^
			if ( GetAsyncKeyState( VK_LBUTTON ) < 0 ) {//{^Ă
				if ( v.GetLength() < R ) {//{[̔aȓȂ
					ball[i].bGrab = true;
				}
			} else {//{^𗣂Ă
				ball[i].bGrab = false;
			}

			CVector2d f;//(kgm/s~2)
			//d
			f = CVector2d( 0.f, GRAVITY * WEIGHT );//d
			ball[i].vVelo += f / WEIGHT * dTick/NUM_SIM; //x(=/d)xiϕj
			//΂˂̗
			if ( ball[i].bGrab ) {//{[ł
				f = v * -K;
				ball[i].vVelo += f / WEIGHT * dTick/NUM_SIM; //x(=/d)xiϕj
			}
			//ʒuXV
			ball[i].vPos += ball[i].vVelo * dTick/NUM_SIM; //xʒuiϕj
			//ǂƂ̏Փ(̑傫́A6.4mA4.8mƂj
			if ( ball[i].vPos.GetX() < R ) {//
				ball[i].vPos.SetX( R );
				ball[i].vVelo.SetX( -ball[i].vVelo.GetX() * E );
			}
			if ( ball[i].vPos.GetX() > 6.40f - R ) {//E
				ball[i].vPos.SetX( 6.40f - R );
				ball[i].vVelo.SetX( -ball[i].vVelo.GetX() * E );
			}
			if ( ball[i].vPos.GetY() > 4.80f - R ) {//
				ball[i].vPos.SetY( 4.80f - R );
				ball[i].vVelo.SetY( -ball[i].vVelo.GetY() * E );
			}
			//̍S
			if ( i > 0 ) {
				v = ball[i-1].vPos - ball[i].vPos;
				v = v.GetNormal() * LENGTH;//̒ɐݒ
				CVector2d vC = (ball[i-1].vPos + ball[i].vPos)/2.f;//Q̃{[̒S
				ball[i-1].vPos = vC + v * 0.5f;
				ball[i].vPos = vC - v * 0.5f;
			}
		}
	}
	//`
	for ( i = 0 ; i < NUM ; i++ ) {
		//{[̕`
		Circle( pDC, ball[i].vPos * dScale, R * dScale );
		//΂˂̕`
		if ( ball[i].bGrab ) {
			MoveTo( pDC, ball[i].vPos * dScale );
			LineTo( pDC, vPoint * dScale );
		}
		if ( i > 0 ) {
			//̕`
			MoveTo( pDC, ball[i-1].vPos * dScale );
			LineTo( pDC, ball[i].vPos * dScale );
		}
	}
	//nʂ̕`
	MoveTo( pDC, 0.f * dScale, 0.f * dScale );
	LineTo( pDC, 0.f * dScale, 4.80f * dScale );
	LineTo( pDC, 6.40f * dScale, 4.80f * dScale );
	LineTo( pDC, 6.40f * dScale, 0.f * dScale );
}

//}EXʒu
CVector2d CBaseView::InputMouse() const {
	CPoint pt;
	GetCursorPos( &pt );//}EXʒu
	CPoint p1 = ConvertCoord( 0.f, 0.f );
	CPoint p2 = ConvertCoord( 640.f, 480.f );
	ClientToScreen( &p1 );
	ClientToScreen( &p2 );
	CVector2d vPoint( (pt.x-p1.x)*6.40f/(p2.x-p1.x), 
		(pt.y-p1.y)*4.80f/(p2.y-p1.y) );//}EX̍WnV~[VWn֕ϊ
	return vPoint;
}

void CBaseView::MoveTo(CDC* pDC, CVector v ){
	//pe@
	double x = v.x * cos(DEG2RAD(-30.0)) + v.y * cos(DEG2RAD(-150));
	double y = v.x * sin(DEG2RAD(-30.0)) + v.y * sin(DEG2RAD(-150)) - v.z;
	MoveTo(pDC,x+320.0,y+240.0);
}
void CBaseView::LineTo(CDC* pDC, CVector v ){
	//pe@
	double x = v.x * cos(DEG2RAD(-30.0)) + v.y * cos(DEG2RAD(-150));
	double y = v.x * sin(DEG2RAD(-30.0)) + v.y * sin(DEG2RAD(-150)) - v.z;
	LineTo(pDC,x+320.0,y+240.0);
}

void CBaseView::MoveTo(CDC* pDC, CVector2d v ){
	MoveTo(pDC,v.GetX(),v.GetY());
}
void CBaseView::LineTo(CDC* pDC, CVector2d v ){
	LineTo(pDC,v.GetX(),v.GetY());
}

//~̕`
void CBaseView::Circle(CDC* pDC, CVector2d v, double r ){
	pDC->SelectStockObject(NULL_BRUSH);
	CPoint p1 = ConvertCoord(v.GetX()-r,v.GetY()-r);
	CPoint p2 = ConvertCoord(v.GetX()+r,v.GetY()+r);
	pDC->Ellipse(p1.x,p1.y,p2.x,p2.y);
}

void CBaseView::MoveTo(CDC* pDC, double x, double y ) 
{
	CPoint p = ConvertCoord( x, y );
	pDC->MoveTo( p );
}

void CBaseView::LineTo(CDC* pDC, double x, double y ) 
{
	CPoint p = ConvertCoord( x, y );
	pDC->LineTo( p );
}

CPoint CBaseView::ConvertCoord( double x, double y ) const
{
	CPoint p;
	CRect cr;
	GetClientRect( &cr );
	if ( cr.right > cr.bottom ) {
		double w =(double)cr.bottom * 640.0/480.0;
		p.x = (int)((double)cr.bottom * x / 480.0 + ((double)cr.right-w)/2);
		p.y = (int)((double)cr.bottom * y / 480.0);
	} else {
		double h =(double)cr.right * 480.0 / 640.0;
		p.x = (int)((double)cr.right * x / 640.0);
		p.y = (int)((double)cr.right * y / 640.0 + ((double)cr.bottom-h)/2);
	}
	return p;
}
/////////////////////////////////////////////////////////////////////////////
// CBaseView NẌ

BOOL CBaseView::OnPreparePrinting(CPrintInfo* pInfo)
{
	return DoPreparePrinting(pInfo);
}

void CBaseView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
}

void CBaseView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
}

/////////////////////////////////////////////////////////////////////////////
// CBaseView NX̐ff

#ifdef _DEBUG
void CBaseView::AssertValid() const
{
	CView::AssertValid();
}

void CBaseView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CBaseDoc* CBaseView::GetDocument() // fobO o[W̓CCłB
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CBaseDoc)));
	return (CBaseDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CBaseView NX̃bZ[W nh

int CBaseView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CView::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	//^C}[Zbg
	SetTimer(1,50,NULL);
	return 0;
}

void CBaseView::OnDestroy() 
{
	CView::OnDestroy();
	//^C}[폜
	KillTimer(1);	
}

void CBaseView::OnTimer(UINT nIDEvent) 
{
	Invalidate(TRUE);	
	CView::OnTimer(nIDEvent);
}


void CBaseView::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	if ( nChar == VK_SPACE ) {//Xy[XL[
		m_nScene ++;//̃V[
	}
	CView::OnKeyDown(nChar, nRepCnt, nFlags);
}
