//////////////////////////////////////////////////////////////////////////////
//CVector2dNX
//Purpose   : double^̂Q̃xNgNX
//Note      : surfix2d2doublë
//Programed : Eiji Kamiya : 1998/07/06 : ProjectDPPorting

#ifndef __VECTOR2D__
#define __VECTOR2D__
#include <assert.h>
#include <math.h>

#define VECTOR2D_NUM_ELEMENT 2

class CVector2d {
protected:
	//f[^o
	double	m_dElement[VECTOR2D_NUM_ELEMENT] ;
		//m_dElement[0] ... x
		//m_dElement[1] ... y

public:
	//RXgN^
	CVector2d(){
		m_dElement[0] = 0.0 ;
		m_dElement[1] = 0.0 ;
	}
	
	//tRXgN^
	CVector2d(double dX, double dY ){
		m_dElement[0] = dX ;
		m_dElement[1] = dY ;
	}
	
	//Rs[RXgN^
	CVector2d( const CVector2d& vec ) {
		for( int i = 0 ; i < VECTOR2D_NUM_ELEMENT ; i++ ) {
			m_dElement[i] = vec.m_dElement[i] ;
		}
	}
	
	//fXgN^
	~CVector2d(){}
	
	//vf̎擾
	double GetElement( int nRow ) const{
		assert( 0 <= nRow && nRow < VECTOR2D_NUM_ELEMENT );
		return m_dElement[nRow];
	}
	
	//x̎擾
	double GetX() const { return m_dElement[0] ; }
	
	//y̎擾
	double GetY() const { return m_dElement[1] ; }
	
	//vf̐ݒ
	void SetElement(int nRow, double dVal) {
		assert( 0 <= nRow && nRow < VECTOR2D_NUM_ELEMENT) ;
		m_dElement[nRow] = dVal;
	}
	
	//x̐ݒ
	void SetX( double dVal ) { m_dElement[0] = dVal; }
	
	//y̐ݒ
	void SetY( double dVal ) { m_dElement[1] = dVal; }
	
	//vf̐ݒ
	void Set( double dX, double dY ) {
		m_dElement[0] = dX ;
		m_dElement[1] = dY ;
	}
	
	//xNg̒
	inline double GetLength() const;
	
	//PʃxNg擾
	CVector2d GetNormal() const {
		CVector2d ret(1.0, 0.0);
		double l = GetLength();
		if ( l > 0.0001 ) {
			ret.m_dElement[0] = m_dElement[0] / l;
			ret.m_dElement[1] = m_dElement[1] / l;
		}
		return ret;
	}
	//PʃxNg
	inline bool Normalize() ;

	//̃xNg]xNg߂
	CVector2d GetRotate( double fTheta ) const {
		CVector2d ret;
		ret.m_dElement[0] =  cos( fTheta ) * m_dElement[0] + sin( fTheta ) * m_dElement[1];
		ret.m_dElement[1] = -sin( fTheta ) * m_dElement[0] + cos( fTheta ) * m_dElement[1];
		return ret;
	}

	//xNg̉]
	void Rotate( double fTheta ) {
		double x =  cos( fTheta ) * m_dElement[0] + sin( fTheta ) * m_dElement[1];
		double y = -sin( fTheta ) * m_dElement[0] + cos( fTheta ) * m_dElement[1];
		m_dElement[0] = x;
		m_dElement[1] = y;
	}

	//
	inline CVector2d& operator=( const CVector2d& vec ) ;
	
	//a
	inline CVector2d operator+( const CVector2d& vec) const;
	
	//Z
	inline CVector2d& operator+=( const CVector2d& vec);
	
	//
	inline CVector2d operator-( const CVector2d& vec) const;
	
	//Z
	inline CVector2d& operator-=( const CVector2d& vec);
	
	//XJ[
	inline CVector2d operator*(double dVal) const;
	
	//XJ[
	inline CVector2d& operator*=(double dVal);
	
	//XJ[ρiXJ[Ou)
	friend CVector2d operator*(double dVal, const CVector2d& vec);
	
	//XJ[
	inline CVector2d operator/(double dVal) const;
	
	//XJ[
	inline CVector2d& operator/=(double dVal);
	
	//XJ[(XJ[Ou)
	friend CVector2d operator/(double dVal, const CVector2d& vec);
	
	//r
	inline bool operator==(const CVector2d& vec) const;
	
	//r
	inline bool operator!=(const CVector2d& vec) const;
	
	//
	inline double DotProduct( const CVector2d& vec) const;
	
	//O
	//Return : QȂ̂ŊOς͂ȂA(x1,y1,0)*(x2,y2,0)ƂƂ
	//         (0,0,z3) z3l߂l
	inline double CrossProduct( const CVector2d& vec) const;
	
	//s|
//	inline CVector2d operator*( const CMatrix& mtrx) const;
	
	//s|
//	inline CVector2d& operator*=( const CMatrix& mtrx);

	//(fobOp)
	//Parameter :
	//            str : (O) o͐obt@iR[ŊmۂĂƁj
	//Return    : o͐obt@̐擪AhX
	//Note      : o͌` "( %ld, %ld )"
	char* Print( char* str ) const{
		sprintf( str, "( %ld, %ld )", m_dElement[0], m_dElement[1] ) ;
		return str ;
	}
};

inline double CVector2d::GetLength() const {
	double l = 0.0 ;
	for ( int i = 0 ; i < VECTOR2D_NUM_ELEMENT ; i++ ) {
		l += m_dElement[i]* m_dElement[i] ;
	}
	return sqrt( l ) ;
}

inline bool CVector2d::Normalize() {
	double dLen = GetLength() ;
	if ( dLen > 0.0 ) {
		for ( int i = 0 ; i < VECTOR2D_NUM_ELEMENT ; i++ ) {
			m_dElement[i] /= dLen ;
		}
		return true ;
	}
	return false ;
}

inline CVector2d& CVector2d::operator=( const CVector2d& vec)
{
	for(int i = 0; i < VECTOR2D_NUM_ELEMENT ; i++ ){
		m_dElement[i] = vec.GetElement(i);
	}
	return *this;
}

inline CVector2d CVector2d::operator+( const CVector2d& vec) const
{
	return CVector2d(
		m_dElement[0] + vec.m_dElement[0],
		m_dElement[1] + vec.m_dElement[1] );
}

inline CVector2d& CVector2d::operator+=( const CVector2d& vec){
	m_dElement[0]+=vec.m_dElement[0];
	m_dElement[1]+=vec.m_dElement[1];
	return *this;
}

inline CVector2d CVector2d::operator-( const CVector2d& vec) const
{
	return CVector2d(
		m_dElement[0] - vec.m_dElement[0],
		m_dElement[1] - vec.m_dElement[1] );
}

inline CVector2d& CVector2d::operator-=( const CVector2d& vec){
	m_dElement[0]-=vec.m_dElement[0];
	m_dElement[1]-=vec.m_dElement[1];
	return *this;
}

inline CVector2d CVector2d::operator*(double dVal) const
{
	return CVector2d(
		m_dElement[0] * dVal,
		m_dElement[1] * dVal );
}

inline CVector2d& CVector2d::operator*=(double dVal)
{
	m_dElement[0] *= dVal;
	m_dElement[1] *= dVal;
	return *this;
}

inline CVector2d CVector2d::operator/(double dVal) const
{
	return CVector2d(
		m_dElement[0] / dVal,
		m_dElement[1] / dVal );
}

inline CVector2d& CVector2d::operator/=(double dVal)
{
	m_dElement[0] /= dVal;
	m_dElement[1] /= dVal;
	return *this;
}

inline bool CVector2d::operator==( const CVector2d& vec) const
{
	for(int nRow = 0; nRow < VECTOR2D_NUM_ELEMENT ; nRow++ ){
		if(m_dElement[nRow]!=vec.m_dElement[nRow]){
			return false;
		}
	}
	return true;
}

inline bool CVector2d::operator!=( const CVector2d& vec) const
{
	return !((*this)==vec);
}

inline double CVector2d::DotProduct( const CVector2d& vec) const
{
	double l = 0.0 ;
	for( int i = 0 ; i < VECTOR2D_NUM_ELEMENT ; i++ ) {
		l += m_dElement[i] * m_dElement[i] ;
	}
	return l ;
}

inline double CVector2d::CrossProduct( const CVector2d& vec) const
{
	return m_dElement[0] * vec.m_dElement[1] - m_dElement[1] * vec.m_dElement[0] ;
}

inline CVector2d operator*( double dVal, const CVector2d& vec )
{
	return CVector2d(
		dVal * vec.m_dElement[0],
		dVal * vec.m_dElement[1] );
}

#endif //__VECTOR2D
